<i18n>
{
  "fr": {
    "ges-1point5": "GES 1point5",
    "initiatives": "Les initiatives",
    "simulators": "Simulateurs",
    "commutes-simulator": "Le simulateur domicile-travail",
    "travels-simulator": "Le simulateur missions",
    "purchases-simulator": "Le simulateur des achats",
    "administration": "Administration",
    "my-laboratory": "Mon laboratoire",
    "ghgis": "Les BGES",
    "log-out": "Me déconnecter",
    "ghgi-title": "BGES"
  },
  "en": {
    "ges-1point5": "GES 1point5",
    "initiatives": "Initiatives",
    "simulators": "Simulators",
    "commutes-simulator": "Commutes simulator",
    "travels-simulator": "Travels simulator",
    "purchases-simulator": "Purchases simulator",
    "administration": "Administration",
    "my-laboratory": "My laboratory",
    "ghgis": "GHG inventories",
    "log-out": "Log out",
    "ghgi-title": "GHGI"
  }
}
</i18n>

<template>
  <section class="hero mb-20"
    :class="(home)?'has-bg-img-home':'has-bg-img'"
    :style="(home)?'min-height:575px':''"
  >
    <!-- Hero head: will stick at the top -->
    <div class="hero-head">
      <nav class="navbar is-fresh">
        <div class="container">
          <div class="navbar-brand">
            <router-link class="navbar-item" to="/">
              <img
                src="../assets/labos1p5_logo_white.png"
                alt=""
              />
            </router-link>
          </div>
          <div id="navbar-menu" class="navbar-menu is-static">
            <div class="navbar-end">
              <div class="navbar-item has-dropdown">
                <router-link class="navbar-link" to="/">
                  <b-icon icon="home" type="is-white" size="is-small"></b-icon>
                </router-link>
              </div>
              <div class="navbar-item has-dropdown">
                <router-link class="navbar-link" to="/ges-1point5">
                  {{ $t('ges-1point5') }}
                </router-link>
              </div>
              <div class="navbar-item has-dropdown">
                <router-link class="navbar-link" to="/les-initiatives">
                  {{ $t('initiatives') }}
                </router-link>
              </div>
              <div class="navbar-item has-dropdown">
                <a class="navbar-link">
                  {{ $t('simulators') }}
                </a>
                <div class="navbar-dropdown">
                  <router-link class="navbar-item" to="/commutes-simulator">
                    {{ $t('commutes-simulator') }}
                  </router-link>
                  <router-link class="navbar-item" to="/travels-simulator">
                    {{ $t('travels-simulator') }}
                  </router-link>
                  <router-link class="navbar-item" to="/purchases-simulator">
                    {{ $t('purchases-simulator') }}
                  </router-link>
                </div>
              </div>
              <div class="logbox">
                <a v-if="!isAuthenticated" @click="displayUserMenu">
                  <b-icon icon="user-o"></b-icon>
                </a>
                <a v-else>
                  <b-icon icon="bars"></b-icon>
                </a>
                <div class="logbox-dropdown" v-if="isAuthenticated">
                  <b-icon icon="barrrs"></b-icon>
                  <ul>
                    <li v-if="isSuperUser">
                      <div class="logbox-ico">
                        <div class="logbox-label">{{ $t('administration') }}</div>
                        <router-link to="/administration/ges-1point5-admin">
                          <b-icon icon="cogs"></b-icon>
                        </router-link>
                      </div>
                    </li>
                    <li>
                      <div class="logbox-ico">
                        <div class="logbox-label">{{ $t('my-laboratory') }}</div>
                        <router-link to="/administration/my-laboratory">
                          <b-icon icon="flask"></b-icon>
                        </router-link>
                      </div>
                    </li>
                    <li>
                      <div class="logbox-ico">
                        <div class="logbox-label">{{ $t('ghgis') }}</div>
                        <router-link to="/administration/all-ghgi">
                          <b-icon icon="thermometer"></b-icon>
                        </router-link>
                      </div>
                    </li>
                    <li>
                      <div class="logbox-ico">
                        <div class="logbox-label">{{ $t('initiatives') }}</div>
                        <router-link to="/administration/initiatives">
                          <b-icon icon="lightbulb-o"></b-icon>
                        </router-link>
                      </div>
                    </li>
                    <li>
                      <div class="logbox-ico">
                        <div class="logbox-label">{{ $t('log-out') }}</div>
                        <a @click="logOut">
                          <b-icon icon="sign-out"></b-icon>
                        </a>
                      </div>
                    </li>
                  </ul>
                </div>
              </div>
              <b-modal :active.sync="isAuthModalOpen" width="500px">
                <auth-modal/>
              </b-modal>
              <language-switcher class="navbar-item"/>
            </div>
          </div>
        </div>
      </nav>
    </div>
    <!-- Hero content: will be in the middle -->
    <div class="hero-body">
      <div v-if=home class="container has-text-centered">
        <h1 class="main-title">
          {{ title }}
        </h1>
        <h2 class="main-subtitle">
          {{ subtitle }}
        </h2>
      </div>
    </div>
    <div style="display: flex;margin: auto;z-index:10">
      <div v-if=!home class="subpage-title1">
        <img class="subpage-img" src="../assets/LogoRond_BlancPourEcran.png">
      </div>
      <div v-if=!home  class="subpage-title2">
        <div  class="subpage-title3">
          {{ title }}
        </div>
      </div>
    </div>
    <div style="margin-top:-35px">
      <svg class="waves" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"
      viewBox="0 24 150 28" preserveAspectRatio="none" shape-rendering="auto">
        <defs>
          <path id="gentle-wave" d="M-160 44c30 0 58-18 88-18s 58 18 88 18 58-18 88-18 58 18 88 18 v44h-352z" />
        </defs>
        <g>
          <use xlink:href="#gentle-wave" x="48" y="0" fill="rgba(255,255,255,0.7" />
          <use xlink:href="#gentle-wave" x="48" y="3" fill="rgba(255,255,255,0.5)" />
          <use xlink:href="#gentle-wave" x="48" y="5" fill="rgba(255,255,255,0.3)" />
          <use xlink:href="#gentle-wave" x="48" y="7" fill="#fff" />
        </g>
      </svg>
    </div>
    <!--Waves end-->
  </section>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  name: 'MainNavbar',
  components: {
    'language-switcher': () => import('@/layout/LanguageSwitcher.vue'),
    'auth-modal': () => import('@/layout/AuthModal.vue')
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    isAuthModalOpen: {
      get: function () {
        return this.$store.getters['authentication/isAuthModalOpen']
      },
      set: function (value) {
        this.$store.dispatch('authentication/closeAuthModal')
      }
    },
    isSuperUser: function () {
      return this.$store.getters['authentication/isSuperUser']
    },
    title: function () {
      let title = null
      if (this.$i18n.locale === 'en' && this.$route.meta.titleen) {
        title = this.$route.meta.titleen
      } else {
        title = this.$route.meta.titlefr
      }
      if (this.$route.name === 'ges-1point5-id' && this.$store.getters['ghgi/item']['year']) {
        title += ' - ' + this.$t('ghgi-title') + ' ' + this.$store.getters['ghgi/item']['year']
      } else if (this.$route.name === 'ges-1point5-results' && this.$store.getters['ghgi/item']['year']) {
        title += ' - ' + this.$t('ghgi-title') + ' ' + this.$store.getters['ghgi/item']['year']
      }
      return title
    },
    subtitle: function () {
      if (this.$i18n.locale === 'en' && this.$route.meta.titleen) {
        return this.$route.meta.subtitleen
      } else {
        return this.$route.meta.subtitlefr
      }
    },
    home: function () {
      if (this.$route.meta.home) {
        return true
      } else {
        return false
      }
    }
  },
  methods: {
    displayUserMenu () {
      if (!this.isAuthenticated) {
        this.$store.dispatch('authentication/openAuthModal')
      }
    },
    logOut () {
      this.$store.dispatch('authentication/authLogout')
        .then(() => {
          this.$router.push('/').catch(() => {})
        })
    }
  },
  mounted () {
    if (this.isAuthenticated) {
      this.$store.dispatch('authentication/isSuperUser')
    }
  }
}
</script>
